<?xml version="1.0"?>
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>
      TextGrid : Preview
    </title>
    <link rel="stylesheet" href="styles/site.css" type="text/css"/>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
  </head>
  <body class="theme-default aui-theme-default">
    <div id="page">
      <div id="main" class="aui-page-panel">
        <div id="main-header">
          <div id="breadcrumb-section">
            <ol id="breadcrumbs">
              <li class="first">
                <span><a href="index.html">TextGrid</a></span>
              </li>
              <li>
                <span><a href="User-Manual-2.0_7439056.html">User Manual 2.0</a></span>
              </li>
              <li>
                <span><a href="General-Object-Editing_7440089.html">General Object Editing</a></span>
              </li>
              <li>
                <span><a href="XML-Editor_7439318.html">XML Editor</a></span>
              </li>
              <li>
                <span><a href="Editor-Field_7439334.html">Editor Field</a></span>
              </li>
            </ol>
          </div>
          <h1 id="title-heading" class="pagetitle">
            <span id="title-text">TextGrid : Preview</span>
          </h1>
        </div>
        <div id="content" class="view">
          <div class="page-metadata">
            Created by <span class="author">Celia Krause</span>, last modified by <span class="editor">Thorsten Vitt</span> on Sep 24, 2015
          </div>
          <div id="main-content" class="wiki-content group">
            <p>
              If you associate an XML Object with an adequate XSLT document, the Preview will show the HTML resulting from this operation. To associate the XSLT file to a XML Document, add a stylesheet declaration to your XML:
            </p>
            <div class="code panel pdl" style="border-width: 1px;">
              <div class="codeContent panelContent pdl">
                <pre class="theme: Confluence; brush: xml; gutter: false" style="font-size:12px;">&lt;?xml-stylesheet type="text/xsl" href="URI of the Stylesheet"?&gt;</pre>
              </div>
            </div>
            <p>
              "URL of the Stylesheet" can also be the URI of the XSLT object in TextGrid (right click the stylesheet in the navigator and select <em>Copy URI</em> to copy its URI to the clipboard). The context menu of the preview window is the same as in your operating system<span style="color: rgb(51,51,51);">.</span>
            </p>
            <p>
              <span style="color: rgb(51,51,51);">The TextGridLab bundles a version of Saxon's Home Edition, so you can use XSLT 2.0 stylesheets here.</span>
            </p>
            <p>
              <span style="color: rgb(51,51,51);"><span class="status-macro aui-lozenge aui-lozenge-current">TEXTGRIDLAB ≥ 2.3</span>When there is no <code>&lt;?xml-stylesheet?&gt;</code> declaration and you are editing a TEI document, the preview page will try to render your XML document using a default stylesheet. This will use <a href="https://github.com/TEIC/Stylesheets" class="external-link" rel="nofollow">the TEI's HTML stylesheets (by Sebastian Rahtz)</a> by default, but you can configure it in the <a href="Preferences_9012401.html">Preferences</a> at <em>XML</em> / <em>Experimental Features</em>. You can use <a href="https://www.textgridlab.org/1.0/aggregator/stylesheets/preview.xsl" class="external-link" rel="nofollow">https://www.textgridlab.org/1.0/aggregator/stylesheets/preview.xsl</a> to render an approximate simulation how your document would look like when published to textgridrep.de.<br/></span>
            </p>
            <h2 id="Preview-AccessingTextGridresourcesfromwithinyourstylesheet">
              <span style="color: rgb(51,51,51);">Accessing TextGrid resources from within your stylesheet</span><span style="color: rgb(51,51,51);"> </span>
            </h2>
            <p>
              <span style="color: rgb(51,51,51);">The XSLT processor that produces the HTML is able to resolve <code>textgrid:</code> URIs and thus to access TextGrid documents directly with the permissions of the user currently signed into the TextGridLab. This means that you can for example use the <code>document()</code> XPath function using TextGrid URIs, e.g., assuming <code>@url = 'textgrid:4711.0'</code>,</span>
            </p>
            <div class="code panel pdl" style="border-width: 1px;">
              <div class="codeContent panelContent pdl">
                <pre class="theme: Confluence; brush: xml; gutter: false" style="font-size:12px;">&lt;xsl:apply-templates select="document(@url)"/&gt;</pre>
              </div>
            </div>
            <p>
              <span style="color: rgb(51,51,51);">will work.<br/></span>
            </p>
            <p>
              <span style="color: rgb(51,51,51);"><span class="status-macro aui-lozenge aui-lozenge-current">TEXTGRIDLAB &gt; 2.1.1</span> However, the embedded browser that will display the resulting HTML is <em>not</em> able to handle <code>textgrid:</code> URIs directly. If you would like, e.g., the browser to display the images that are referred to in your source document using something like <code>&lt;tei:pb facs="textgrid:4711.0"/&gt;</code>, you will first have to translate that into a http(s) URL. To help you with that, the preview page will pass the XSLT processor a parameter called <code>graphicsURLPattern</code>. This parameter's value will contain a string containing the special substring <code>@URI@</code>, and when you replace <code>@URI@</code> with the textgrid: URI of the image, you will get a https URL that the browser can use (and that already contains authentication information). So, the following XSLT fragment an handle the pb case mentioned above:</span>
            </p>
            <div class="code panel pdl" style="border-width: 1px;">
              <div class="codeContent panelContent pdl">
                <pre class="theme: Confluence; brush: xml; gutter: false" style="font-size:12px;">&lt;xsl:param name="graphicsURLPattern"/&gt;

&lt;xsl:template match="tei:pb[@facs]"&gt;
  &lt;img class="facsimile" src="{replace($graphicsURLPattern, '@URI@', @facs)}"/&gt;
&lt;/xsl:template&gt;</pre>
              </div>
            </div>
            <p>
              <span style="color: rgb(51,51,51);"><br/></span>
            </p>
          </div>
        </div>
      </div>
      <div id="footer" role="contentinfo">
        <section class="footer-body">
          
          <div id="footer-logo">
            <a href="http://www.atlassian.com/">Atlassian</a>
          </div>
        </section>
      </div>
    </div>
  </body>
</html>
